__author__ = 'delerue'

from PIL import Image
import subprocess
import time
import urllib
from datetime import datetime
from bpm_constants import *
from writeclient import writeclient

#global SCOPE_IP 
#SCOPE_IP = '10.0.1.112'
scope_image_url="http://"+SCOPE_IP+"/crt_print.png"

def read_image(image_name_and_path):
    p = subprocess.Popen(["display",image_name_and_path])
    print "tic"
    time.sleep(10)
    print "toc"
    p.kill()


def read_images_from_scope(nimages):
    iimage=1
    subproc=0
    start_time_str=datetime.now().strftime("%Y%m%d_%H%M%S")
    for iimage in range(nimages):
        image_name_and_path=data_dir+"scope_image_"+start_time_str+"_"+str(iimage)+".png"
        urllib.urlretrieve(scope_image_url,image_name_and_path)
        if (subproc !=0):
            subproc.kill()
        subproc = subprocess.Popen(["display",image_name_and_path])
        time.sleep(2)
    time.sleep(10)
    if (subproc !=0):
        subproc.kill()



def scpi_query(command):
    reply=writeclient(SCOPE_IP,5025,command+chr(10),1)
    print "SCPI: ",command," => ", reply
    return reply

def scpi_command(command):
    writeclient(SCOPE_IP,5025,command+chr(10),1)
    print "SCPI: ",command

def turn_on():
    scpi_command('CHAN1:STAT ON \nCHAN1:STAT?')
    scpi_command('CHAN2:STAT ON \nCHAN2:STAT?')
    scpi_command('CHAN3:STAT ON \nCHAN1:STAT?')
    scpi_command('CHAN4:STAT ON \nCHAN2:STAT?')
    scpi_command('CURS1:STAT ON \nCURS1:STAT?')

def turn_off():
    scpi_command('CURS1:STAT OFF \nCURS1:STAT?')
    scpi_command('CHAN1:STAT OFF \nCHAN1:STAT?')
    scpi_command('CHAN2:STAT OFF \nCHAN2:STAT?')
    scpi_command('CHAN3:STAT OFF \nCHAN2:STAT?')
    scpi_command('CHAN4:STAT OFF \nCHAN2:STAT?')

def suppress_alignea(l):
    L = ''
    for i in l:
        if not(i == '\n'):
            L += i
    return(L)
    
def read_scope_and_write(position, fichier):
    fichier.write(str(position)+' ')
    L = [position]
    for i in range(4):
	scpi_command('CURS1:SOUR CH'+str(i+1)+' \n CURS1:SOUR?')
	valeur = scpi_query('CURS1:FUNC UPE \n CURS:RES?')
        valeur = suppress_alignea(valeur)
        L.append(float(valeur))
        fichier.write(valeur+' ')
    fichier.write('\n')
    return(L)
        




